-- this lua is reusable/open source
-- made by sdas#8133

rawset(_G, "sdasoldhud", true);

local showpowers = CV_FindVar("powerupdisplay")

local function enable_21_hud()
   -- old hud positions
   hudinfo[HUD_RINGSNUM].x = 112
   hudinfo[HUD_MINUTES].x = 88
   hudinfo[HUD_TIMECOLON].x = 88
   hudinfo[HUD_SECONDS].x = 112
   hudinfo[HUD_TIMETICCOLON].x = 112
   hudinfo[HUD_TICS].x = 136
   hudinfo[HUD_TIME].x = 16
   hudinfo[HUD_SCORENUM].x = 128
   hudinfo[HUD_POWERUPS].x = 32767
   hudinfo[HUD_POWERUPS].y = 32767
end

local function disable_21_hud()
   hudinfo[HUD_RINGSNUM].x = 96
   hudinfo[HUD_MINUTES].x = 72
   hudinfo[HUD_TIMECOLON].x = 72
   hudinfo[HUD_SECONDS].x = 96
   hudinfo[HUD_TIMETICCOLON].x = 96
   hudinfo[HUD_TICS].x = 120
   hudinfo[HUD_TIME].x = 16
   hudinfo[HUD_SCORENUM].x = 120
   hudinfo[HUD_POWERUPS].x = 288
   hudinfo[HUD_POWERUPS].y = 176
end

rawset(_G, "enable_21_hud", CV_RegisterVar(
   {
      name = "enable_2.1_hud",
      defaultvalue = "On",
      flags = CV_CALL | CV_SHOWMODIF,
      PosibleValue = CV_OnOff,
      func = function(var)
         if not var.value then disable_21_hud() else enable_21_hud() end
      end
   }
));

enable_21_hud()

hud.add(function (draw, player, cam)
   local jumpshield = draw.cachePatch("TVWWICON");
   local watershield = draw.cachePatch("TVELICON");
   local bombshield = draw.cachePatch("TVARICON");
   local attractshield = draw.cachePatch("TVATICON");
   local pityshield = draw.cachePatch("TVPIICON");
   local sneakers = draw.cachePatch("TVSSICON");
   local forceshield = draw.cachePatch("TVFOICON");
   local flameshield = draw.cachePatch("TVFLICON");
   local bubbleshield = draw.cachePatch("TVBBICON");
   local thundershield = draw.cachePatch("TVZPICON");
   local amyshield = draw.cachePatch("TVPPICON");
   local invincibility = draw.cachePatch("TVIVICON");
   local gravboots = draw.cachePatch("TVGVICON");
   local goal = draw.cachePatch("FNSHICO");
   local gotrflag = draw.cachePatch("GOTRFLAG");
   local gotbflag = draw.cachePatch("GOTBFLAG");

   local p = nil;
   
   if not showpowers.value and camera.chase then return end
   if player.playerstate ~= PST_LIVE then return end

   -- shield
   if player.powers[pw_shield] & SH_FORCE then
      if ((player.powers[pw_shield] & 0xFF > 0) or leveltime & 1) then
         p = forceshield
      end
   else
      local check = player.powers[pw_shield] & SH_NOSTACK
      if check == SH_WHIRLWIND then
         p=jumpshield
      elseif check == SH_ELEMENTAL then
         p=watershield
      elseif check == SH_ARMAGEDDON then
         p=bombshield
      elseif check == SH_ATTRACT then
         p=attractshield
      elseif check == SH_PITY then
         p=pityshield
      elseif check == SH_FLAMEAURA then
         p=flameshield
      elseif check == SH_BUBBLEWRAP then
         p=bubbleshield
      elseif check == SH_THUNDERCOIN then
         p=thundershield
      elseif check == SH_PINK then
         p=amyshield
      end
   end

   if p then
      draw.draw(304, 24, p, V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS)
   end

   -- invincibility
   local invulntime
   if player.powers[pw_flashing] then
      invulntime = 1
   else
      invulntime = player.powers[pw_invulnerability]
   end

   if invulntime > 3*TICRATE or (invulntime and leveltime & 1) then
      draw.draw(304, 24+28, invincibility, V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS)
   end
   -- sneakers
   if player.powers[pw_sneakers] > 3*TICRATE or (player.powers[pw_sneakers] and leveltime & 1) then
      draw.draw(304, 24+56, sneakers, V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS)
   end

   -- ctf flags
   if player.gotflag then
      local p;
      if player.gotflag & GF_REDFLAG then
         p = gotrflag
      else
         p = gotbflag
      end

      draw.draw(304, 24+84, p, V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS)
   end

   -- gravity boots
   if player.powers[pw_gravityboots] > 3*TICRATE or (player.powers[pw_gravityboots] and leveltime & 1) then
      draw.draw(152, 24, gravboots, V_SNAPTORIGHT|V_HUDTRANS)
   end

   --finish icon
   if player.pflags & PF_FINISHED then
      draw.draw(298, 203, goal, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_HUDTRANS)
   end
end)

--old titlecard
hud.disable("stagetitle")

local function levelnamewidth(str)
   --idk how to replicate that better but i would just return string len * 16
   return string.len(str) * 16
end

hud.add(function (draw, player, timeinmap, endtime)
   local lvlttl = mapheaderinfo[gamemap].lvlttl
   local subttl = mapheaderinfo[gamemap].subttl
   local actnum = mapheaderinfo[gamemap].actnum
   local subttlxpos = 320/2
   local lvlttlxpos
   local ttlnumxpos
   local zonexpos

   local lvlttly
   local zoney
   local ttlnum

   if not (timeinmap > 2 and timeinmap-3 < 110) then return end

   --im too lazy to fix actnumbers above 19, so i just hide it if it's above 19
   if actnum > 19 then
      actnum = 0
   end
   if actnum > 0 then
      local str = "TTL"
      if actnum < 10 then
         str = "TTL0"
      end
      ttlnum = draw.cachePatch(str..actnum)
      lvlttlxpos = ((320/2) - (levelnamewidth(lvlttl)/2)) - ttlnum.width
   else
      lvlttlxpos = ((320/2) - (levelnamewidth(lvlttl)/2))
   end

   ttlnumxpos = lvlttlxpos + levelnamewidth(lvlttl)
   zonexpos = ttlnumxpos - levelnamewidth("ZONE")

   if lvlttlxpos < 0 then
      lvlttlxpos = 0;
   end

   local check = timeinmap-3
   if check == 0 then   zoney = 200; lvlttly =   0;
   elseif check == 1 then   zoney = 188; lvlttly =  12;
   elseif check == 2 then   zoney = 176; lvlttly =  24;
   elseif check == 3 then   zoney = 164; lvlttly =  36;
   elseif check == 4 then   zoney = 152; lvlttly =  48;
   elseif check == 5 then   zoney = 140; lvlttly =  60;
   elseif check == 6 then   zoney = 128; lvlttly =  72;
   elseif check == 105 then zoney =  80; lvlttly = 104;
   elseif check == 106 then zoney =  56; lvlttly = 128;
   elseif check == 107 then zoney =  32; lvlttly = 152;
   elseif check == 108 then zoney =   8; lvlttly = 176;
   elseif check == 109 then zoney =   0; lvlttly = 200;
   else  zoney = 104; lvlttly =  80; end

   if actnum then
      draw.draw(ttlnumxpos, zoney, ttlnum)
   end

   draw.drawLevelTitle(lvlttlxpos, lvlttly, lvlttl)

   if not (mapheaderinfo[gamemap].levelflags & LF_NOZONE) then
      draw.drawLevelTitle(zonexpos, zoney, "ZONE")
   end

   if lvlttly+48 < 200 then
      draw.drawString(subttlxpos, lvlttly+48, subttl, V_ALLOWLOWERCASE)
   end

end, "titlecard")